Index: src/Shapes/unittests/ShapeOpsUnitTest.cpp
===================================================================
--- src/Shapes/unittests/ShapeOpsUnitTest.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Shapes/unittests/ShapeOpsUnitTest.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,265 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010-2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * ShapeOpsUnitTest.cpp
+ *
+ *  Created on: Jun 18, 2010
+ *      Author: crueger
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include <cmath>
+#include <limits>
+
+#ifdef HAVE_TESTRUNNER
+#include "UnitTestMain.hpp"
+#endif /*HAVE_TESTRUNNER*/
+
+#include "CodePatterns/Assert.hpp"
+
+#include "Helpers/defs.hpp"
+#include "LinearAlgebra/RealSpaceMatrix.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "Shapes/BaseShapes.hpp"
+#include "Shapes/Shape.hpp"
+#include "Shapes/ShapeOps.hpp"
+
+#include "ShapeOpsUnitTest.hpp"
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( ShapeOpsTest );
+
+void ShapeOpsTest::setUp()
+{
+  // failing asserts should be thrown
+  ASSERT_DO(Assert::Throw);
+}
+
+void ShapeOpsTest::tearDown()
+{}
+
+void ShapeOpsTest::resizeTest()
+{
+  Shape s = resize(Sphere(), 2.);
+
+  CPPUNIT_ASSERT( s.isInside( Vector(1.5,0.,0.) ) );
+  CPPUNIT_ASSERT( s.isInside( Vector(0.,1.5,0.) ) );
+  CPPUNIT_ASSERT( s.isInside( Vector(0.,0.,1.5) ) );
+  CPPUNIT_ASSERT( s.isOnSurface( Vector(2.,0.,0.) ) );
+  CPPUNIT_ASSERT( s.isOnSurface( Vector(0.,2.,0.) ) );
+  CPPUNIT_ASSERT( s.isOnSurface( Vector(0.,0.,2.) ) );
+}
+
+void ShapeOpsTest::translateTest()
+{
+  Shape s = translate(Sphere(), Vector(1.,0.,0.));
+
+  CPPUNIT_ASSERT( s.isInside( Vector(1.5,0.,0.) ) );
+  CPPUNIT_ASSERT( s.isInside( Vector(1.,.5,0.) ) );
+  CPPUNIT_ASSERT( s.isInside( Vector(1.,0.,.5) ) );
+  CPPUNIT_ASSERT( s.isOnSurface( Vector(2.,0.,0.) ) );
+  CPPUNIT_ASSERT( s.isOnSurface( Vector(1.,1.,0.) ) );
+  CPPUNIT_ASSERT( s.isOnSurface( Vector(1.,0.,1.) ) );
+  CPPUNIT_ASSERT( !s.isInside( Vector(-.5,0.,0.) ) );
+  CPPUNIT_ASSERT( !s.isInside( Vector(0.,-.5,0.) ) );
+  CPPUNIT_ASSERT( !s.isInside( Vector(0.,0.,-.5) ) );
+}
+
+void ShapeOpsTest::stretchTest()
+{
+#ifndef NDEBUG
+  CPPUNIT_ASSERT_THROW( Shape test = stretch(Sphere(), Vector(-2.,0.,0.)), Assert::AssertionFailure );
+#endif
+  Shape s = stretch(Sphere(), Vector(2.,1.,1.));
+
+  CPPUNIT_ASSERT( s.isInside( Vector(1.5,0.,0.) ) );
+  CPPUNIT_ASSERT( !s.isInside( Vector(0.,1.5,0.) ) );
+  CPPUNIT_ASSERT( !s.isInside( Vector(0.,0.,1.5) ) );
+  CPPUNIT_ASSERT( s.isOnSurface( Vector(2.,0.,0.) ) );
+  CPPUNIT_ASSERT( s.isOnSurface( Vector(0.,1.,0.) ) );
+  CPPUNIT_ASSERT( s.isOnSurface( Vector(0.,1.,0.) ) );
+}
+
+void ShapeOpsTest::transformTest()
+{
+  RealSpaceMatrix M;
+  M.setRotation(45., 0., 0.);
+  Shape s = transform(Sphere(), M);
+
+  CPPUNIT_ASSERT( s.isInside( Vector(.5,0.,0.) ) );
+  CPPUNIT_ASSERT( s.isInside( Vector(0.,.5,0.) ) );
+  CPPUNIT_ASSERT( s.isInside( Vector(0.,0.,.5) ) );
+  CPPUNIT_ASSERT( s.isOnSurface( Vector(1.,0.,0.) ) );
+  CPPUNIT_ASSERT( s.isOnSurface( Vector(0.,1.,0.) ) );
+  CPPUNIT_ASSERT( s.isOnSurface( Vector(0.,0.,1.) ) );
+}
+
+void ShapeOpsTest::getCenterTest()
+{
+  Shape s = Sphere();
+  Shape t = Sphere(Vector(2.,0.,0.),1.);
+  Vector offset(1.,0.,0);
+  RealSpaceMatrix M;
+  M.setRotation(45.,0.,0.);
+
+  // Sphere
+  {
+    // sphere at origin
+    CPPUNIT_ASSERT_EQUAL( Vector(0.,0.,0), s.getCenter() );
+
+    // translated sphere
+    CPPUNIT_ASSERT_EQUAL( offset, translate(s, offset).getCenter() );
+
+    // resized sphere
+    CPPUNIT_ASSERT_EQUAL( Vector(0.,0.,0), resize(s, 2.).getCenter() );
+
+    // stretched sphere
+    CPPUNIT_ASSERT_EQUAL( Vector(0.,0.,0), stretch(s, Vector(2.,1.,1.)).getCenter() );
+
+    // transformed sphere
+    CPPUNIT_ASSERT_EQUAL( Vector(0.,0.,0), transform(s, M).getCenter() );
+
+    // resized and translated sphere
+    CPPUNIT_ASSERT_EQUAL( offset, translate(resize(s, 2.), offset).getCenter() );
+  }
+
+  // AND spheres
+  {
+    // sphere at origin
+    CPPUNIT_ASSERT_EQUAL( Vector(1.,0.,0), (s && t).getCenter() );
+
+    // translated sphere
+    CPPUNIT_ASSERT_EQUAL( Vector(2.,0.,0), translate((s && t), offset).getCenter() );
+
+    // resized sphere
+    CPPUNIT_ASSERT_EQUAL( Vector(1.,0.,0), resize((s && t), 2.).getCenter() );
+
+    // stretched sphere
+    CPPUNIT_ASSERT_EQUAL( Vector(1.5,0.,0), (stretch(s, Vector(2.,1.,1.)) && t).getCenter() );
+
+    // transformed sphere
+    CPPUNIT_ASSERT_EQUAL( Vector(1.,0.,0), (transform(s, M) && t).getCenter() );
+
+    // resized and translated sphere
+    CPPUNIT_ASSERT_EQUAL( Vector(2.,0.,0), translate(resize((s && t), 2.), offset).getCenter() );
+  }
+
+  // OR spheres
+  {
+    // sphere at origin
+    CPPUNIT_ASSERT_EQUAL( Vector(1.,0.,0), (s || t).getCenter() );
+
+    // translated sphere
+    CPPUNIT_ASSERT_EQUAL( Vector(2.,0.,0), translate((s || t), offset).getCenter() );
+
+    // resized sphere
+    CPPUNIT_ASSERT_EQUAL( Vector(1.,0.,0), resize((s || t), 2.).getCenter() );
+
+    // stretched sphere
+    CPPUNIT_ASSERT_EQUAL( Vector(0.5,0.,0), (stretch(s, Vector(2.,1.,1.)) || t).getCenter() );
+
+    // transformed sphere
+    CPPUNIT_ASSERT_EQUAL( Vector(1.,0.,0), (transform(s, M) || t).getCenter() );
+
+    // resized and translated sphere
+    CPPUNIT_ASSERT_EQUAL( Vector(2.,0.,0), translate(resize((s || t), 2.), offset).getCenter() );
+  }
+
+  // NOT spheres
+  {
+    // sphere at origin
+    CPPUNIT_ASSERT_EQUAL( Vector(0.,0.,0), (!s).getCenter() );
+  }
+}
+
+void ShapeOpsTest::getRadiusTest()
+{
+  Shape s = Sphere();
+  Shape t = Sphere(Vector(2.,0.,0.),1.);
+  Vector offset(1.,0.,0);
+  RealSpaceMatrix M;
+  M.setRotation(45.,0.,0.);
+
+  // Sphere
+  {
+    // sphere at origin
+    CPPUNIT_ASSERT_EQUAL( 1., s.getRadius() );
+
+    // translated sphere
+    CPPUNIT_ASSERT_EQUAL( 1., translate(s, offset).getRadius() );
+
+    // resized sphere
+    CPPUNIT_ASSERT_EQUAL( 2., resize(s, 2.).getRadius() );
+
+    // stretched sphere
+    CPPUNIT_ASSERT_EQUAL( 2., stretch(s, Vector(2.,1.,1.)).getRadius() );
+
+    // transformed sphere
+    CPPUNIT_ASSERT_EQUAL( 1., transform(s, M).getRadius() );
+
+    // resized and translated sphere
+    CPPUNIT_ASSERT_EQUAL( 2., translate(resize(s, 2.), offset).getRadius() );
+  }
+
+  // AND spheres
+  {
+    // sphere at origin
+    CPPUNIT_ASSERT_EQUAL( 1., (s && t).getRadius() );
+
+    // translated sphere
+    CPPUNIT_ASSERT_EQUAL( 1., translate((s && t), offset).getRadius() );
+
+    // resized sphere
+    CPPUNIT_ASSERT_EQUAL( 2., resize((s && t), 2.).getRadius() );
+
+    // stretched sphere
+    CPPUNIT_ASSERT_EQUAL( 1., (stretch(s, Vector(2.,1.,1.)) && t).getRadius() );
+
+    // transformed sphere
+    CPPUNIT_ASSERT_EQUAL( 1., (transform(s, M) && t).getRadius() );
+
+    // resized and translated sphere
+    CPPUNIT_ASSERT_EQUAL( 2., translate(resize((s && t), 2.), offset).getRadius() );
+  }
+
+  // OR spheres
+  {
+    // sphere at origin
+    CPPUNIT_ASSERT_EQUAL( 2., (s || t).getRadius() );
+
+    // translated sphere
+    CPPUNIT_ASSERT_EQUAL( 2., translate((s || t), offset).getRadius() );
+
+    // resized sphere
+    CPPUNIT_ASSERT_EQUAL( 4., resize((s || t), 2.).getRadius() );
+
+    // stretched sphere
+    CPPUNIT_ASSERT_EQUAL( 2.5, (stretch(s, Vector(2.,1.,1.)) || t).getRadius() );
+
+    // transformed sphere
+    CPPUNIT_ASSERT_EQUAL( 2., (transform(s, M) || t).getRadius() );
+
+    // resized and translated sphere
+    CPPUNIT_ASSERT_EQUAL( 4., translate(resize((s || t), 2.), offset).getRadius() );
+  }
+
+  // NOT spheres
+  {
+    // sphere at origin
+    CPPUNIT_ASSERT_EQUAL( std::numeric_limits<double>::infinity(), (!s).getRadius() );
+  }
+}
+
Index: src/Shapes/unittests/ShapeOpsUnitTest.hpp
===================================================================
--- src/Shapes/unittests/ShapeOpsUnitTest.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Shapes/unittests/ShapeOpsUnitTest.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,42 @@
+/*
+ * ShapeOpsUnitTest.hpp
+ *
+ *  Created on: Jun 18, 2010
+ *      Author: crueger
+ */
+
+#ifndef SHAPEOPSUNITTEST_HPP_
+#define SHAPEOPSUNITTEST_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include <cppunit/extensions/HelperMacros.h>
+
+class ShapeOpsTest : public CppUnit::TestFixture
+{
+  CPPUNIT_TEST_SUITE( ShapeOpsTest) ;
+  CPPUNIT_TEST ( resizeTest );
+  CPPUNIT_TEST ( translateTest );
+  CPPUNIT_TEST ( stretchTest );
+  CPPUNIT_TEST ( transformTest );
+  CPPUNIT_TEST ( getCenterTest );
+  CPPUNIT_TEST ( getRadiusTest );
+  CPPUNIT_TEST_SUITE_END();
+
+public:
+  void setUp();
+  void tearDown();
+
+  void resizeTest();
+  void translateTest();
+  void stretchTest();
+  void transformTest();
+  void getCenterTest();
+  void getRadiusTest();
+};
+
+#endif /* SHAPEOPSUNITTEST_HPP_ */
Index: src/Shapes/unittests/Shape_HomogeneousPointsUnitTest.cpp
===================================================================
--- src/Shapes/unittests/Shape_HomogeneousPointsUnitTest.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Shapes/unittests/Shape_HomogeneousPointsUnitTest.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,64 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010-2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * Shape_HomogeneousPointsUnitTest.cpp
+ *
+ *  Created on: Jun 19, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include <cmath>
+#include <limits>
+
+#ifdef HAVE_TESTRUNNER
+#include "UnitTestMain.hpp"
+#endif /*HAVE_TESTRUNNER*/
+
+#include "CodePatterns/Assert.hpp"
+
+#include "Shapes/BaseShapes.hpp"
+#include "Shapes/Shape.hpp"
+
+#include "Shape_HomogeneousPointsUnitTest.hpp"
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( Shape_HomogeneousPointsTest );
+
+void Shape_HomogeneousPointsTest::setUp()
+{
+  // failing asserts should be thrown
+  ASSERT_DO(Assert::Throw);
+}
+
+void Shape_HomogeneousPointsTest::tearDown()
+{}
+
+/** Unit test for points on Shape's surface.
+ *
+ */
+void Shape_HomogeneousPointsTest::surfaceTest()
+{
+	CPPUNIT_ASSERT(true);
+}
+
+/** Unit test for points in Shape's volume.
+ *
+ */
+void Shape_HomogeneousPointsTest::volumeTest()
+{
+	CPPUNIT_ASSERT(true);
+}
Index: src/Shapes/unittests/Shape_HomogeneousPointsUnitTest.hpp
===================================================================
--- src/Shapes/unittests/Shape_HomogeneousPointsUnitTest.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Shapes/unittests/Shape_HomogeneousPointsUnitTest.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,34 @@
+/*
+ * Shape_HomogeneousPointsUnitTest.hpp
+ *
+ *  Created on: Jun 19, 2010
+ *      Author: heber
+ */
+
+#ifndef SHAPE_HOMOGENEOUSPOINTSUNITTEST_HPP_
+#define SHAPE_HOMOGENEOUSPOINTSUNITTEST_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include <cppunit/extensions/HelperMacros.h>
+
+class Shape_HomogeneousPointsTest : public CppUnit::TestFixture
+{
+  CPPUNIT_TEST_SUITE( Shape_HomogeneousPointsTest) ;
+  CPPUNIT_TEST ( surfaceTest );
+  CPPUNIT_TEST ( volumeTest );
+  CPPUNIT_TEST_SUITE_END();
+
+public:
+  void setUp();
+  void tearDown();
+
+  void surfaceTest();
+  void volumeTest();
+};
+
+#endif /* SHAPE_HOMOGENEOUSPOINTSUNITTEST_HPP_ */
Index: src/Shapes/unittests/stubs/ApproximateShapeAreaStub.cpp
===================================================================
--- src/Shapes/unittests/stubs/ApproximateShapeAreaStub.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Shapes/unittests/stubs/ApproximateShapeAreaStub.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,34 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * ApproximateShapeArea.cpp
+ *
+ *  Created on: Jan 30, 2012
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "Tesselation/ApproximateShapeArea.hpp"
+
+ApproximateShapeArea::ApproximateShapeArea(const Shape &_shape) :
+		shape(_shape)
+{}
+
+ApproximateShapeArea::~ApproximateShapeArea()
+{}
+
+double ApproximateShapeArea::operator()() const
+{
+	return 0.;
+}
Index: src/Shapes/unittests/stubs/ApproximateShapeVolumeStub.cpp
===================================================================
--- src/Shapes/unittests/stubs/ApproximateShapeVolumeStub.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Shapes/unittests/stubs/ApproximateShapeVolumeStub.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,34 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * ApproximateShapeVolume.cpp
+ *
+ *  Created on: Jan 30, 2012
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "Tesselation/ApproximateShapeVolume.hpp"
+
+ApproximateShapeVolume::ApproximateShapeVolume(const Shape &_shape) :
+		shape(_shape)
+{}
+
+ApproximateShapeVolume::~ApproximateShapeVolume()
+{}
+
+double ApproximateShapeVolume::operator()() const
+{
+	return 0.;
+}
Index: src/Tesselation/ApproximateShapeArea.cpp
===================================================================
--- src/Tesselation/ApproximateShapeArea.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Tesselation/ApproximateShapeArea.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,86 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * ApproximateShapeArea.cpp
+ *
+ *  Created on: Jan 30, 2012
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include <cmath>
+#include <set>
+#include <vector>
+
+#include "Atom/TesselPoint.hpp"
+#include "LinkedCell/PointCloudAdaptor.hpp"
+#include "ApproximateShapeArea.hpp"
+#include "Tesselation/tesselation.hpp"
+
+/** Constructor of class ApproximateShapeArea.
+ *
+ * @param _shape shape to calculate the surface area approximately
+ */
+ApproximateShapeArea::ApproximateShapeArea(const Shape &_shape) :
+		shape(_shape)
+{}
+
+/** Destructor of class ApproximateShapeArea.
+ *
+ */
+ApproximateShapeArea::~ApproximateShapeArea()
+{}
+
+/** Calculate the approximate surface area of the given \a shape.
+ *
+ * @return surface area approximated
+ */
+double ApproximateShapeArea::operator()() const
+{
+  const double distance = 2.;
+  const double min_area = distance*distance*distance;
+  const double radius = shape.getRadius();
+  const double surfacearea_upperbound = 4.*M_PI * radius*radius;
+  const size_t N = (int)(surfacearea_upperbound/min_area);
+  // get surface points
+  std::vector<Vector> SurfacePoints =
+      shape.getHomogeneousPointsOnSurface(N);
+  typedef std::set<TesselPoint *> NodeSet;
+  NodeSet SurfaceNodes;
+  for (size_t i=0;i<SurfacePoints.size();++i) {
+    TesselPoint * Walker = new TesselPoint();
+    Walker->setName(std::string("SurfaceNode")+toString(i));
+    Walker->setPosition(SurfacePoints[i]);
+    SurfaceNodes.insert(Walker);
+  }
+
+  // tesselate
+  PointCloudAdaptor<NodeSet> cloud(&SurfaceNodes, "TesselPointSTLList");
+  Tesselation *tesselator = new Tesselation;
+  (*tesselator)(cloud, distance);
+
+  // obtain surface area (assume angstroem)
+  const double surfacearea = tesselator->getAreaOfEnvelope(true);
+
+  // clear up
+  delete tesselator;
+  for (NodeSet::iterator iter = SurfaceNodes.begin();
+      !SurfaceNodes.empty(); iter = SurfaceNodes.begin()) {
+    delete *iter;
+    SurfaceNodes.erase(iter);
+  }
+
+  return surfacearea;
+}
+
Index: src/Tesselation/ApproximateShapeArea.hpp
===================================================================
--- src/Tesselation/ApproximateShapeArea.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Tesselation/ApproximateShapeArea.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,36 @@
+/*
+ * ApproximateShapeArea.hpp
+ *
+ *  Created on: Jan 30, 2012
+ *      Author: heber
+ */
+
+#ifndef APPROXIMATESHAPEAREA_HPP_
+#define APPROXIMATESHAPEAREA_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Shapes/Shape.hpp"
+
+/** Functor for the approximate surface are of a shape.
+ *
+ * This class is just an intermediate until we have implemented a better way
+ * to calculate the surface area within the constructuve solid geometry method.
+ */
+class ApproximateShapeArea
+{
+public:
+	ApproximateShapeArea(const Shape &_shape);
+	~ApproximateShapeArea();
+
+	double operator()() const;
+
+private:
+	Shape shape;
+};
+
+
+#endif /* APPROXIMATESHAPEAREA_HPP_ */
Index: src/Tesselation/ApproximateShapeVolume.cpp
===================================================================
--- src/Tesselation/ApproximateShapeVolume.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Tesselation/ApproximateShapeVolume.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,76 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * ApproximateShapeVolume.cpp
+ *
+ *  Created on: Jan 30, 2012
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "ApproximateShapeVolume.hpp"
+
+#include <boost/bind.hpp>
+#include <vector>
+
+#include "Box.hpp"
+#include "Filling/Mesh/CubeMesh.hpp"
+#include "Filling/NodeTypes.hpp"
+#include "LinearAlgebra/RealSpaceMatrix.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "World.hpp"
+
+/** Constructor of class ApproximateShapeVolume.
+ *
+ * @param _shape shape to calculate the volume approximately
+ */
+ApproximateShapeVolume::ApproximateShapeVolume(const Shape &_shape) :
+		shape(_shape)
+{}
+
+/** Destructor of class ApproximateShapeVolume.
+ *
+ */
+ApproximateShapeVolume::~ApproximateShapeVolume()
+{}
+
+/** Calculate the approximate volume of the given \a shape.
+ *
+ * @return surface volume approximated
+ */
+double ApproximateShapeVolume::operator()() const
+{
+	// TODO
+	// generate mesh of points to "integrate"
+	const double min_distance = 10.;
+	Vector distance(min_distance,min_distance,min_distance);
+	const RealSpaceMatrix &M = World::getInstance().getDomain().getM();
+	Mesh *mesh = new CubeMesh(distance, Vector(0.5,0.5,0.5), M );
+	NodeSet nodes = mesh->getNodes();
+
+	// fill with grid points and count whether isInside
+	const size_t total = nodes.size();
+	size_t inside = 0;
+	for (NodeSet::const_iterator iter = nodes.begin();
+			iter != nodes.end(); ++iter) {
+		if (shape.isInside(*iter))
+			++inside;
+	}
+
+	// calculate volume of box
+	const double volume = M.determinant();
+
+	// return fraction that is inside
+	return volume*((double)inside/(double)total);
+}
Index: src/Tesselation/ApproximateShapeVolume.hpp
===================================================================
--- src/Tesselation/ApproximateShapeVolume.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Tesselation/ApproximateShapeVolume.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,36 @@
+/*
+ * ApproximateShapeVolume.hpp
+ *
+ *  Created on: Jan 30, 2012
+ *      Author: heber
+ */
+
+#ifndef APPROXIMATESHAPEVOLUME_HPP_
+#define APPROXIMATESHAPEVOLUME_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Shapes/Shape.hpp"
+
+/** Functor for the approximate volume of a shape.
+ *
+ * This class is just an intermediate until we have implemented a better way
+ * to calculate the volume within the constructuve solid geometry method.
+ */
+class ApproximateShapeVolume
+{
+public:
+	ApproximateShapeVolume(const Shape &_shape);
+	~ApproximateShapeVolume();
+
+	double operator()() const;
+
+private:
+	Shape shape;
+};
+
+
+#endif /* APPROXIMATESHAPEVOLUME_HPP_ */
Index: src/Tesselation/BoundaryTriangleSet.cpp
===================================================================
--- src/Tesselation/BoundaryTriangleSet.cpp	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/Tesselation/BoundaryTriangleSet.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -230,52 +230,53 @@
   Vector Direction;
 
-  // 1. get intersection with plane
+  // 1. get intersection with plane and place in ClosestPoint
   LOG(1, "INFO: Looking for closest point of triangle " << *this << " to " << x << ".");
-  GetCenter(Direction);
+  LOG(1, "INFO: endpoints are " << endpoints[0]->node->getPosition() << ","
+      << endpoints[1]->node->getPosition() << ", and " << endpoints[2]->node->getPosition() << ".");
   try {
-    Line l = makeLineThrough(x, Direction);
-    ClosestPoint = Plane(NormalVector, (endpoints[0]->node->getPosition())).GetIntersection(l);
+    ClosestPoint = Plane(NormalVector, (endpoints[0]->node->getPosition())).getClosestPoint(x);
   }
   catch (LinearAlgebraException &excp) {
     (ClosestPoint) = (x);
   }
+  Vector InPlane(ClosestPoint); // points from plane intersection to straight-down point
 
   // 2. Calculate in plane part of line (x, intersection)
-  Vector InPlane = (x) - (ClosestPoint); // points from plane intersection to straight-down point
-  InPlane.ProjectOntoPlane(NormalVector);
-  InPlane += ClosestPoint;
-
-  LOG(2, "INFO: Triangle is " << *this << ".");
-  LOG(2, "INFO: Line is from " << Direction << " to " << x << ".");
-  LOG(2, "INFO: In-plane part is " << InPlane << ".");
+  LOG(2, "INFO: Closest point on triangle plane is " << ClosestPoint << ".");
 
   // Calculate cross point between one baseline and the desired point such that distance is shortest
-  double ShortestDistance = -1.;
-  bool InsideFlag = false;
   Vector CrossDirection[3];
   Vector CrossPoint[3];
-  Vector helper;
   for (int i = 0; i < 3; i++) {
-    // treat direction of line as normal of a (cut)plane and the desired point x as the plane offset, the intersect line with point
-    Direction = (endpoints[(i+1)%3]->node->getPosition()) - (endpoints[i%3]->node->getPosition());
+    const Vector Direction = (endpoints[i%3]->node->getPosition()) - (endpoints[(i+1)%3]->node->getPosition());
     // calculate intersection, line can never be parallel to Direction (is the same vector as PlaneNormal);
     Line l = makeLineThrough((endpoints[i%3]->node->getPosition()), (endpoints[(i+1)%3]->node->getPosition()));
-    CrossPoint[i] = Plane(Direction, InPlane).GetIntersection(l);
-    CrossDirection[i] = CrossPoint[i] - InPlane;
-    CrossPoint[i] -= (endpoints[i%3]->node->getPosition());  // cross point was returned as absolute vector
+    CrossPoint[i] = l.getClosestPoint(InPlane);
+    // NOTE: direction of line is normalized, hence s must not necessarily be in [0,1] for the baseline
+    LOG(2, "INFO: Closest point on line from " << (endpoints[(i+1)%3]->node->getPosition())
+        << " to " << (endpoints[i%3]->node->getPosition()) << " is " << CrossPoint[i] << ".");
+    CrossPoint[i] -= (endpoints[(i+1)%3]->node->getPosition());  // cross point was returned as absolute vector
     const double s = CrossPoint[i].ScalarProduct(Direction)/Direction.NormSquared();
     LOG(2, "INFO: Factor s is " << s << ".");
     if ((s >= -MYEPSILON) && ((s-1.) <= MYEPSILON)) {
-          CrossPoint[i] += (endpoints[i%3]->node->getPosition());  // make cross point absolute again
-      LOG(2, "INFO: Crosspoint is " << CrossPoint[i] << ", intersecting BoundaryLine between " << endpoints[i % 3]->node->getPosition() << " and " << endpoints[(i + 1) % 3]->node->getPosition() << ".");
-      const double distance = CrossPoint[i].DistanceSquared(x);
-      if ((ShortestDistance < 0.) || (ShortestDistance > distance)) {
-        ShortestDistance = distance;
-        (ClosestPoint) = CrossPoint[i];
-      }
-    } else
-      CrossPoint[i].Zero();
-  }
-  InsideFlag = true;
+      CrossPoint[i] += (endpoints[(i+1)%3]->node->getPosition());  // make cross point absolute again
+      LOG(2, "INFO: Crosspoint is " << CrossPoint[i] << ", intersecting BoundaryLine between "
+          << endpoints[i % 3]->node->getPosition() << " and "
+          << endpoints[(i + 1) % 3]->node->getPosition() << ".");
+    } else {
+      // set to either endpoint of BoundaryLine
+      if (s < -MYEPSILON)
+        CrossPoint[i] = (endpoints[(i+1)%3]->node->getPosition());
+      else
+        CrossPoint[i] = (endpoints[i%3]->node->getPosition());
+      LOG(2, "INFO: Crosspoint is " << CrossPoint[i] << ", intersecting outside of BoundaryLine between "
+          << endpoints[i % 3]->node->getPosition() << " and "
+          << endpoints[(i + 1) % 3]->node->getPosition() << ".");
+    }
+    CrossDirection[i] = CrossPoint[i] - InPlane;
+  }
+
+  bool InsideFlag = true;
+  double ShortestDistance = -1.;
   for (int i = 0; i < 3; i++) {
     const double sign = CrossDirection[i].ScalarProduct(CrossDirection[(i + 1) % 3]);
@@ -284,17 +285,17 @@
     if ((sign > -MYEPSILON) && (othersign > -MYEPSILON)) // have different sign
       InsideFlag = false;
-  }
+    // update current best candidate
+    const double distance = CrossPoint[i].DistanceSquared(x);
+    if ((ShortestDistance < 0.) || (ShortestDistance > distance)) {
+      ShortestDistance = distance;
+      (ClosestPoint) = CrossPoint[i];
+    }
+  }
+
   if (InsideFlag) {
     (ClosestPoint) = InPlane;
     ShortestDistance = InPlane.DistanceSquared(x);
-  } else { // also check endnodes
-    for (int i = 0; i < 3; i++) {
-      const double distance = x.DistanceSquared(endpoints[i]->node->getPosition());
-      if ((ShortestDistance < 0.) || (ShortestDistance > distance)) {
-        ShortestDistance = distance;
-        (ClosestPoint) = (endpoints[i]->node->getPosition());
-      }
-    }
-  }
+  }
+
   LOG(1, "INFO: Closest Point is " << ClosestPoint << " with shortest squared distance is " << ShortestDistance << ".");
   return ShortestDistance;
@@ -370,4 +371,79 @@
 }
 ;
+
+/** Checks whether a given point is inside the plane of the triangle and inside the
+ * bounds defined by its BoundaryLineSet's.
+ *
+ * @param point point to check
+ * @return true - point is inside place and inside all BoundaryLine's
+ */
+bool BoundaryTriangleSet::IsInsideTriangle(const Vector &point) const
+{
+  Info FunctionInfo(__func__);
+
+  // check if it's inside the plane
+  try {
+    Plane trianglePlane(
+        endpoints[0]->node->getPosition(),
+        endpoints[1]->node->getPosition(),
+        endpoints[2]->node->getPosition());
+    if (!trianglePlane.isContained(point)) {
+      LOG(1, "INFO: Point " << point << " is not inside plane " << trianglePlane << " by "
+          << trianglePlane.distance(point) << ".");
+      return false;
+    }
+  } catch(LinearDependenceException) {
+    // triangle is degenerated, it's just a line (i.e. one endpoint is right in between two others
+    for (size_t i = 0; i < NDIM; ++i) {
+      try {
+        Line l = makeLineThrough(
+            lines[i]->endpoints[0]->node->getPosition(),
+            lines[i]->endpoints[1]->node->getPosition());
+        if (l.isContained(GetThirdEndpoint(lines[i])->node->getPosition())) {
+          // we have the largest of the three lines
+          LOG(1, "INFO: Linear-dependent case where point " << point << " is on line " << l << ".");
+          return (l.isContained(point));
+        }
+      } catch(ZeroVectorException) {
+        // two points actually coincide
+        try {
+          Line l = makeLineThrough(
+              lines[i]->endpoints[0]->node->getPosition(),
+              GetThirdEndpoint(lines[i])->node->getPosition());
+          LOG(1, "INFO: Degenerated case where point " << point << " is on line " << l << ".");
+          return (l.isContained(point));
+        } catch(ZeroVectorException) {
+          // all three points coincide
+          if (point.DistanceSquared(lines[i]->endpoints[0]->node->getPosition()) < MYEPSILON) {
+            LOG(1, "INFO: Full-Degenerated case where point " << point << " is on three endpoints "
+                << lines[i]->endpoints[0]->node->getPosition() << ".");
+            return true;
+          }
+          else return false;
+        }
+      }
+    }
+  }
+
+  // check whether it lies on the correct side as given by third endpoint for
+  // each BoundaryLine.
+  // NOTE: we assume here that endpoints are linear independent, as the case
+  // has been caught before already extensively
+  for (size_t i = 0; i < NDIM; ++i) {
+    Line l = makeLineThrough(
+        lines[i]->endpoints[0]->node->getPosition(),
+        lines[i]->endpoints[1]->node->getPosition());
+    Vector onLine( l.getClosestPoint(point) );
+    LOG(1, "INFO: Closest point on boundary line is " << onLine << ".");
+    Vector inTriangleDirection( GetThirdEndpoint(lines[i])->node->getPosition() - onLine );
+    Vector inPointDirection(point - onLine);
+    if ((inTriangleDirection.NormSquared() > MYEPSILON) && (inPointDirection.NormSquared() > MYEPSILON))
+      if (inTriangleDirection.ScalarProduct(inPointDirection) < -MYEPSILON)
+        return false;
+  }
+
+  return true;
+}
+
 
 /** Returns the endpoint which is not contained in the given \a *line.
Index: src/Tesselation/BoundaryTriangleSet.hpp
===================================================================
--- src/Tesselation/BoundaryTriangleSet.hpp	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/Tesselation/BoundaryTriangleSet.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -42,4 +42,5 @@
     bool IsPresentTupel(const BoundaryPointSet * const Points[3]) const;
     bool IsPresentTupel(const BoundaryTriangleSet * const T) const;
+    bool IsInsideTriangle(const Vector &point) const;
 
     Plane getPlane() const;
Index: src/Tesselation/boundary.cpp
===================================================================
--- src/Tesselation/boundary.cpp	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/Tesselation/boundary.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -1029,5 +1029,5 @@
   for (int i=0;i<NDIM;i++) {
     phi[i] = (random()/(rng_max-rng_min))*(2.*M_PI);
-    std::cout << "Random angle is " << phi[i] << std::endl;
+    LOG(4, "DEBUG: Random angle is " << phi[i] << ".");
   }
 
